# ChainX

[![License: GPL v3](https://img.shields.io/badge/License-GPLv3-blue.svg)](./LICENSE)
[![CI](https://github.com/chainx-org/ChainX/workflows/ci/badge.svg)](https://github.com/chainx-org/ChainX/actions?workflow=ci)

[ChainX](https://github.com/chainx-org/ChainX) is a community-driven project built on the next-generation blockchain framework [substrate](https://github.com/paritytech/substrate), the largest Layer-2 network of Bitcoin using the Light-client protocol with smart contract support, spawn as the third relay chain besides Polkadot/Kusama. SherpaX and MiniX will be added as a parachain.

Based on the LayerZero protocol, the EVM Layer2 ecology on ChainX can share the liquidity of the EVM ecology such as ETH/BSC, and the POW payment coin such as BTC/DogeCoin can share the DAPP ecology of the EVM.
[light white paper](https://chainx.org/static/media/Chainx.3df914fe.pdf).
[website](https://chainx.org)

## The Fragmented Web3 Crypto World
There have always been many problems in the crypto world, but there has never been a shortage of reforms and innovations.
* In order to solve the payment performance and scalability problems of BTC, various altcoins such as Dogecoin, LTC, and BCH have been introduced.
* In order to solve the problems of too expensive gas fees in Ethereum and the scalability of dapps, people have successively developed public chains such as BSC, EOS, Polkadot, and Avalanche, which now seem to have a wide users.


However, the establishment of dapps on these mainstream public chains still faces some problems: the ecosystems of different public chains are separated from each other, and the isolation will disperse the value, until the value returns to 0, the aggregation can accumulate the value, making the value like The piles of wood are piled higher and higher.
Also, we cannot exchange tokens on pancakeswap with those on Uniswap because they come from different ecosystems. This will prevent DEXs from having as much liquidity as CEXs. But we must embrace DEXs, because we all know that decentralization is the fundamental attribute and future of the encrypted world, and the meaning of encryption algorithms and even the whole web3 world is decentralization.

Based on this, ChainX, the layer 2 network of Bitcoin, will be committed to solving the above problems and aggregating these divided communities and ecology.

## How ChainX solves the above problems

### To solve the scalability problem of isolated POW tokens such as Bitcoin and Dogecoin
First, we adopted the mode of light node + multi-centralized hosting (integrated with Taproot aggregated signature + MAST contract + Signal distributed computing protocol). Then, we will adopt the on chain lightning network model to completely solve the scalability problem of POW tokens such as BTC in a completely decentralized way.

### To solve the isolation problem of EVM public chains such as ETH/BSC
There are already many solutions for the decentralized cross-chain between EVM chains. We will absorb the LayerZero protocol to realize the cross-chain between decentralized EVM chains.

Later, an aggregation protocol will be deployed on ChainX EVM, so that our DEX can unify liquidity across platforms and chains: for example, pools on UniSwap and pools on PancakeSwap can share liquidity.

In addition, ChainX will realize the consistent mapping between ENS and other various public chain domain name systems. For example, the CID of ComingChat can be mapped with ENS, and ENS can be mapped with BTC addresses.

Aggregation and unification are eternal themes in the crypto world. Aggregation can make the crypto world closer and make web3 competitive enough to replace the web2 world. At the same time, aggregation also prevents LTC, BCH and other DAPP ecologically unprosperous communities from slowly going silent, and the prosperous EVM ecology will also become more prosperous because of aggregation.


## ChainX Ecological Project：
* [ComingChat](https://coming.chat/):Integrated web3 portal for encrypted social, digital identity, NFT, digital wallet, smart contract platform portal and other functions. Committed to being a secure and trusted web3 portal. Combining decentralized encryption algorithms and blockchain knowledge to solve trusted information transmission and asset management problems.
* [SherpaX](https://sherpax.io/): ChainX's EVM & WASM Smart Contract Parachain.
* [MiniX](https://github.com/MinixChain/MinixChain): ChainX's digital identity, NFT, reputation system parachain.
* [SoSwap](https://www.soswap.finance/): Omni-chain DEX, a distributed financial platform dedicated to allowing multiple chains to share liquidity.
* [ComFuture](https://comfuture.coming.chat/): Digital identity, NFT creation auction trading platform.
* USB: The decentralized expansion of BTC that allows BTC and any EVM ecological chain to be integrated with each other.

## The crypto world is not perfect, but ChainX is working hard to make it better and better.
Please refer to the [docs](https://chainx-org.github.io/documentation) for building and developing on ChainX platform.

## Contribution

Any kinds of contributions are highly welcome. Feel free to file an issue if you have any question or run into any issues.

## License

[GPL v3](LICENSE)
